export class Throttler {
    private hasBeenCalledWithinTime = false;
    private lastCallFunc: (() => any) | null = null;

    public constructor(private minimumTimeBetweenCall: number) {}

    public call(func: () => any) {
        this.lastCallFunc = func;
        if (this.hasBeenCalledWithinTime) return;
        this.hasBeenCalledWithinTime = true;
        func();
        setTimeout(() => {
            this.hasBeenCalledWithinTime = false;
            if (this.lastCallFunc) this.lastCallFunc();
        }, this.minimumTimeBetweenCall);
    }
}
